#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include "chat.h"

#define g_stricmp stricmp

/* NB: Different to server side, as this version returns the index into the
	stack (ie for deletion) - also does a strstr instead of stricmp */
int incstack_search(incstack_t* user, char* msg)
{
  int i;

  for (i=0;i<user->size;i++)
    if (strstr(user->msg[i],msg) != NULL)
      return i;

  return -1;
}

int incstack_size(incstack_t* stack)
{
	return stack->size;
}

char* incstack_getmessage(incstack_t* user, int item)
{
	return user->msg[item];
}

int incstack_addmessage(incstack_t* user, char* msg)
{
  char* item;

  item = malloc(strlen(msg)+1);
  strcpy(item,msg);
  
  user->msg[user->size++] = item;
  return 0;
}

/*int stack_svid(CHAT_DATA* user, int item)
{
  int i;
  for (i=0;i<user->stack_size;i++)
    if (user->stack[i]->svid == item)
      return i;

  return -1;
}*/

/*int stack_setclid(CHAT_DATA* user, int svid, int clid)
{
  int i;

  if (svid == 0)
    return 0;

  if ((i = stack_svid(user,svid)) != -1)
    user->stack[i]->clid = clid;

  return 0;
}*/
/*int stack_clid(CHAT_DATA* user, int item)
{
  int i;
  if (item == 0)
	  return -1;

  for (i=0;i<user->stack_size;i++)
    if (user->stack[i]->clid == item)
      return i;

  return -1;
}*/
 
int incstack_delmessage(incstack_t* user, int item)
{
  int i;
  if (item < 0)
    return 0;

  free(user->msg[item]);
  for (i=item;i<user->size-1;i++)
    user->msg[i] = user->msg[i+1];
  user->size--;
  return 0;
}
 
/*int stack_delprevclids(user_t* user, int item)
{
  int i;
  if (item < 0)
    return 0;

  for (i=0;i<user->stack_size;)
    if (user->stack[i]->clid && user->stack[i]->clid < item)
      stack_delmessage(user,i);
    else i++;

  return 0;
}*/

int incstack_empty(incstack_t* user)
{
  int i;

  for (i=0;i<user->size;i++)
    free(user->msg[i]);
  
  user->size = 0;
  return 0;
}

/*int stack_dump(int userid)
{
  user_t* user = users+userid;
  int i;
  printf("Stack:\n");
  for (i=0;i<user->stack_size;i++)
  {
    printf("%d: %s (sv:%d,cl:%d)\n",i+1,user->stack[i]->msg,
        user->stack[i]->svid, user->stack[i]->clid);
  }
  return 0;
}*/
